stages:          
  - build
  - upload
  - create-release

variables:
  GIT_SUBMODULE_STRATEGY: recursive
  WEDP_VERSION: $CI_COMMIT_TAG
  WEDP_BINARY: wedp.dll
  PACKAGE_REGISTRY_URL: "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/wedp/${WEDP_VERSION}"
  

build-job:
  stage: build
  image: vs22-native
  tags:
    - ntninja-windows
  script:
    - msbuild "wedp\\wedp.sln" /p:Configuration=Release /p:Platform="x64"
  rules:
    - if: $CI_COMMIT_TAG
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event" && $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == "master"' 
    - if: $CI_PIPELINE_SOURCE == "web"
  artifacts:
    untracked: false
    when: on_success
    expire_in: 14 days
    paths:
      - "wedp\\x64\\Release\\wedp.dll"


upload-job:
  stage: upload
  image: curlimages/curl:latest
  tags:
    - docker
  needs:
   - job: build-job
     artifacts: true
  rules:
    - if: $CI_COMMIT_TAG
  script:
    - echo "Pushing the artifacts to packages for release $CI_COMMIT_TAG"
    - 'curl --header "JOB-TOKEN: $CI_JOB_TOKEN" --upload-file "wedp/x64/Release/wedp.dll" "${PACKAGE_REGISTRY_URL}/${WEDP_BINARY}"'


release-job:
  stage: create-release
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  tags:
    - docker
  rules:
    - if: $CI_COMMIT_TAG
  needs:
   - job: upload-job
  script:
    - echo "Running the release job"
  release:
    tag_name: $CI_COMMIT_TAG
    name: "Windows Exploit Development Plugin v$CI_COMMIT_TAG"
    description: "Windows Exploit Development Plugin v$CI_COMMIT_TAG"
    assets:
      links:
        - name: "WEDP"
          url: ${PACKAGE_REGISTRY_URL}/${WEDP_BINARY}
